<template lang="pug">
input.input( 
	v-model='value'
	:placeholder='placeholder'
	:type='inputType'
	:class='bindClass'
	onclick="this.showPicker()"
	:max='max'
	:min='min'
	ref="input" )
</template>

<script setup>
import { isValidDate } from "@/components/orders/helpers"
import iMask from "imask"
import dayjs from "@/common/dayjs"

import { computed, onMounted, ref } from "vue"

const props = defineProps({
	modelValue: {
		type: [ String, Number ],
		default: ""
	},
	placeholder: {
		type: String,
		default: ""
	},
	inputType: {
		type: String,
		default: "text"
	},
	type: {
		type: String,
		default: ""
	},
	max: {
		type: String,
		default: ""
	},
	min: {
		type: String,
		default: ""
	}
})
const emit = defineEmits([ "update:modelValue" ])

const input = ref()

const value = computed({
	get: () => props.modelValue,
	set: val => {
		if (props.max && val > props.max) {
			val = props.max
			input.value.value = val
		}

		if (props.min && val < props.min) {
			val = props.min
			input.value.value = val
		}

		emit("update:modelValue", val)
	}
})

const bindClass = computed(() => [ 
	props.type ? `is-${props.type}` : "" 
])

onMounted(() => {
	if (props.type == "birth") {
		let params = {
			mask: Date,

			blocks: {
				d: {
					mask: IMask.MaskedRange,
					from: 1,
					to: 31,
					maxLength: 2,
				},
				m: {
					mask: IMask.MaskedRange,
					from: 1,
					to: 12,
					maxLength: 2,
				},
				Y: {
					mask: IMask.MaskedRange,
					from: 1900,
					to: parseInt(dayjs().format("YYYY")),
				}
			},
			autofix: true,
			lazy: true,
			overwrite: true
		}

		iMask(input.value, params)
	}
})
</script>